!Last update: MEF 2/16/04 11:57 am
PROGRAM ISCAPEX
IMPLICIT NONE
! DECLARE VARIABLES
! FILE NAME VARIABLES
CHARACTER(200):: ISCFILE,RECFILE,AQFILE,DISFILE
CHARACTER(1):: NEED
! SITE ID VARIABLE
CHARACTER(25):: ID
CHARACTER(4):: ISC
! LOGICAL VARIABLES
LOGICAL:: FILEEXIST,LEAP
! INTEGERS 
INTEGER:: IYEAR,NUMOFRECORD,NUMREC,IOS,YEAR,DY,UTMZ
INTEGER, DIMENSION(366):: DAY
! INTEGERS FOR LOOPS
INTEGER:: A,B,I,J,K,N
! REAL NUMBERS
REAL:: P,Q,R
REAL:: CONV
REAL:: UTMX,UTMY,LAT,LONG,X,Y,VALUE
! CONCENTRATION ARRAY
REAL, DIMENSION(366,24):: CONC

! OPEN THE PREEXISTING ISC OUTPUT AND SITE FILE W/ RECEPTOR INFO
10 WRITE (*,*) 'Please enter the ISC output (plot) file name:'
READ (*,*) ISCFILE
 INQUIRE (FILE=ISCFILE, EXIST=FILEEXIST)
 IF (.NOT.FILEEXIST) THEN
  WRITE (*,*) '*File does not exist*'
  GO TO 10
 ELSE IF (FILEEXIST) THEN
  OPEN (10, FILE=ISCFILE, STATUS='OLD')
  READ (10,*)
  READ (10,*)
  READ (10,*)
  READ (10,100) ISC
  100 FORMAT (T11,A4)
  IF (ISC /= 'POST') THEN
   WRITE (*,*) '*Incorrect file type*'
   GO TO 10
  END IF
 END IF
WRITE (*,*) ' '
20 WRITE (*,*) 'Enter the name of the receptor file:'
READ (*,*) RECFILE
 INQUIRE (FILE=RECFILE, EXIST=FILEEXIST)
 IF (.NOT.FILEEXIST) THEN
  WRITE (*,*) 'File does not exist.'
  GO TO 20
 ELSE IF (FILEEXIST) THEN
  OPEN (11, FILE=RECFILE, STATUS='OLD')
 END IF
 
! ACCOUNT FOR POSSIBLE CONVERSION OF CONCENTRATIONS
25 WRITE (*,*)
WRITE (*,*) 'Is a units conversion needed for concentrations? N=no, Y=yes'
READ (*,*) NEED
IF (NEED == 'Y' .OR. NEED == 'y') THEN
 WRITE (*,*) 'Please enter a conversion factor by which the concentrations will be divided.'
 WRITE (*,*) 'To multiply results, enter a decimal value:'
 READ (*,*) CONV
ELSE IF (NEED == 'N' .OR. NEED == 'n') THEN
 CONV = 1
ELSE
 WRITE (*,*) 'Invalid response'
 GO TO 25
END IF

! INPUT START/END DATES AND UTM ZONE 
WRITE (*,*) ' '
30 WRITE (*,*) 'Please enter the year of the simulation.'
READ (*,*) IYEAR
!CHECK FOR LEAP YEAR
P= IYEAR
Q= P/4
Q= NINT(Q)
R= Q*4
LEAP= (P==R)
IF (LEAP) THEN
 WRITE (*,*) 'This is a leap year'
ELSE
 WRITE (*,*) 'This is not a leap year'
END IF

WRITE (*,*) ' '
WRITE (*,*) 'Please provide the UTM zone used:'
READ (*,*) UTMZ
IF (UTMZ < 10 .OR. UTMZ > 19) THEN
 WRITE (*,*) 'Conversion from UTM to Lat/Long may not be correct'
END IF

! CREATE AIR QUALITY AND DISTRCITS FILE FOR APEX INPUT
WRITE (*,*) ' '
WRITE (*,*) 'What should the air quality file be named?'
WRITE (*,*) '*File will be overwritten if it exists*'
READ (*,*) AQFILE
WRITE (*,*) ' '
WRITE (*,*) 'What should the districts file be named?'
WRITE (*,*) '*File will be overwritten if it exists*'
READ (*,*) DISFILE
 INQUIRE (FILE=AQFILE, EXIST=FILEEXIST)
 IF (FILEEXIST) THEN
  OPEN (12, FILE=AQFILE, STATUS='OLD')
 ELSE IF (.NOT.FILEEXIST) THEN
  OPEN (12, FILE=AQFILE, STATUS='NEW')
 END IF
 INQUIRE (FILE=DISFILE, EXIST=FILEEXIST)
 IF (FILEEXIST) THEN
  OPEN (13, FILE=DISFILE, STATUS='OLD')
 ELSE IF (.NOT.FILEEXIST) THEN
  OPEN (13, FILE=DISFILE, STATUS='NEW')
 END IF

! ALL NECESSARY FILES (NEW & OLD) SHOULD NOW BE OPEN

!CHECK NUMBER OF RECEPTORS (RECFILE & ISCFILE) FOR MATCH
NUMOFRECORD = 0
DO
 READ (11,*,IOSTAT=IOS)
 IF (IOS /= 0) EXIT
 NUMOFRECORD = NUMOFRECORD + 1
END DO
WRITE (*,*) ' '
WRITE (*,*) 'Number of receptors in receptor file = ',NUMOFRECORD
REWIND (11)
! SKIP FIRST 4 LINES OF ISCFILE, READ # OF RECEPTORS ON LINE 5
READ (10,120) NUMREC
120 FORMAT (T26,I5)
WRITE (*,*) 'Number of receptors in ISC plot file = ',NUMREC
IF (NUMREC /= NUMOFRECORD) THEN
 WRITE (*,*) 'The number of receptors do not match - please check these files'
 WRITE (*,*) 'ISC Plot file ',ISCFILE
 WRITE (*,*) 'Receptor file ',RECFILE
 WRITE (*,*) 'Please press enter to exit program'
 READ (*,*)
 STOP
END IF

!Verify that year entered matches the year in the ISC file
READ (10,*)
READ (10,*)
READ (10,*)
READ (10,130) YEAR
130 FORMAT (T72,I2)
IF (IYEAR < 2000) THEN
 YEAR = YEAR+1900
ELSE
 YEAR = YEAR+2000
END IF
IF (P /= YEAR) THEN
 WRITE (*,*) 'The year entered (',IYEAR,') does not match the year on the ISC file (',YEAR,')'
 WRITE (*,*) 'Please press enter to exit program'
 READ (*,*)
 STOP
END IF

REWIND (10)

DO I = 1,NUMREC 
 READ (11,*) ID,UTMX,UTMY
 
 CALL UTMCONVERT (UTMX,UTMY,UTMZ,LAT,LONG)
 ! WRITE A LINE OF THE DISTRICTS FILE
 WRITE (*,*) I,' LAT= ',LAT,' LONG= ',LONG
 WRITE (13,200) ID,LAT,LONG,IYEAR,IYEAR
 ! WRITE THE HEADERS FOR SITE(I)
 WRITE (12,210) ID
 WRITE (12,220) UTMX,UTMY
 WRITE (12,*) 'Units = ug/m3'
 WRITE (12,230) IYEAR
 WRITE (12,240) IYEAR
 WRITE (12,250) LAT
 WRITE (12,260) LONG
 
 200 FORMAT (1X,A25,2(1X,F10.5),1X,I4,'0101',1X,I4,'1231')
 210 FORMAT (1X,'Name =',1X,A12)
 220 FORMAT (1X,'ISC Receptor',1X,F13.5,',',1X,F13.5)
 230 FORMAT (1X,'Start Date',T13,'=',1X,I4,'0101')
 240 FORMAT (1X,'End Date',T13,'=',1X,I4,'1231')
 250 FORMAT (1X,'Lat',T13,'=',1X,F6.3)
 260 FORMAT (1X,'Long',T13,'=',1X,F8.3)
 
 !Initialize the value to 0
 VALUE= 0
 
 ! SKIP DOWN TO DATA IN ISC OUTPUT FILE - LINE 9
 READ (10,*)
 READ (10,*)
 READ (10,*)
 READ (10,*)
 READ (10,*)
 READ (10,*)
 READ (10,*)
 READ (10,*)
 
 IF (.NOT.LEAP) THEN
  A=1
  DO WHILE (A<366)
   B=1
   DO WHILE (B<25)
    CONC(A,B)= 0
    READ (10,140) X,Y,VALUE,DY
    140 FORMAT (3(1X,F13.5),T74,I4)
    IF (UTMX .EQ. X .AND. UTMY .EQ. Y) THEN
     VALUE = VALUE / CONV
     CONC(A,B)= VALUE
     B= B + 1
    ELSE
     B= B + 0
    END IF
   END DO
   DAY(A)=DY
   A= A + 1
  END DO
  
  DO J = 1,365
   IF (DAY(J) < 999) THEN
    WRITE (12,300) (CONC(J,K),K= 1,24),IYEAR,DAY(J)
    300 FORMAT (24(1X,ES8.2),1X,I4,'0',I3)
   ELSE
    WRITE (12,310) (CONC(J,K),K= 1,24),IYEAR,DAY(J)
    310 FORMAT (24(1X,ES8.2),1X,I4,I4)
   END IF
  END DO
  
 ELSE IF (LEAP) THEN
  A=1
  DO WHILE (A<367)
   B=1
   DO WHILE (B<25)
    CONC(A,B)= 0
    READ (10,150) X,Y,VALUE,DY
    150 FORMAT (3(1X,F13.5),T74,I4)
    IF (UTMX .EQ. X .AND. UTMY .EQ. Y) THEN
     VALUE = VALUE / CONV
     CONC(A,B)= VALUE
     B= B + 1
    ELSE
     B= B + 0
    END IF
   END DO
   DAY(A)=DY
   A= A + 1
  END DO
  
  DO J = 1,366
   IF (DAY(J) < 999) THEN
    WRITE (12,340) (CONC(J,K),K= 1,24),IYEAR,DAY(J)
    340 FORMAT (24(1X,ES8.2),1X,I4,'0',I3)
   ELSE
    WRITE (12,350) (CONC(J,K),K= 1,24),IYEAR,DAY(J)
    350 FORMAT (24(1X,ES8.2),1X,I4,I4)
   END IF
  END DO
 
 END IF
 
 ! RECEPTOR IS FINISHED.  MOVE TO NEXT RECEPTOR LOCATION
 ! CREATE A BREAK BETWEEN RECEPTORS IN AQFILE
 WRITE (12,*) '  '
 ! GO BACK TO BEGINNING OF ISC INPUT FILE
 CLOSE (10)
 OPEN (10, FILE=ISCFILE, STATUS='OLD')
END DO

ENDFILE (12)
ENDFILE (13)
CLOSE (10)
CLOSE (11)
CLOSE (12)
CLOSE (13)

END PROGRAM ISCAPEX


! THE SUBROUTINE FOR CONVERTING UTM TO LAT/LONG FOLLOWS
! FROM PETER DALY, MIT OCEAN ACOUSTICS (PMD@MIT.EDU)

SUBROUTINE UTMCONVERT (UTMX,UTMY,UTMZ,LAT,LONG)
IMPLICIT NONE
REAL:: UTMX,UTMY,LAT,LONG
INTEGER:: UTMZ,ZONE_LONG
REAL:: A,B,F,E2,E4,E6,E1,E12,E13,E14
REAL:: LAMBDA,LAMBDA0,X,Y,K0,PHI,PHI0,PHI1
REAL:: EP2,CC1,TT1,NN1,RR1,DD,DD2,DD3,DD4,DD5,DD6
REAL:: M_PI,MM,MM0,MU

M_PI= ACOS(-1.0)
A= 6378137
B= 6356752.3

F= 1.0-(B/A)
E2= (2.0*F) - (F*F)
E4= E2*E2
E6= E4*E2

!GET LAMBDA

ZONE_LONG= UTMZ
IF (ZONE_LONG < 1 .OR. ZONE_LONG > 61) THEN
 WRITE (*,*) 'INVALID GRID ZONE'
END IF
LAMBDA0= (FLOAT(ZONE_LONG - 1)*6.0 + (-180.0) + 3.0)*M_PI/180.0

!DO THE REST

K0= 0.9996
X= UTMX - 500000.0
Y= UTMY

PHI0= 0.0
E1= (1.0 - SQRT(1.0-E2))/(1.0 + SQRT(1.0-E2))
E12= E1*E1
E13= E1*E12
E14= E12*E12

MM0= A*((1.0-E2/4.0 - 3.0*E4/64.0 - 5.0*E6/256.0)*PHI0 - &
     (3.0*E2/8.0 + 3.0*E4/32.0 + 45.0*E6/1024.0)*SIN(2.0*PHI0) + &
     (15.0*E4/256.0 + 45.0*E6/1024.0)*SIN(4.0*PHI0) - &
     (35.0*E6/3072.0)*SIN(6.0*PHI0))
MM= MM0 + Y/K0
MU= MM/(A*(1.0-E2/4.0-3.0*E4/64.0-5.0*E6/256.0))

PHI1= MU + (3.0*E1/2.0 - 27.0*E13/32.0)*SIN(2.0*MU) + &
      (21.0*E12/16.0 - 55.0*E14/32.0)*SIN(4.0*MU) + &
      (151.0*E13/96.0)*SIN(6.0*MU) + (1097.0*E14/512.0)*SIN(8.0*MU)

EP2= E2/(1.0 - E2)
CC1= EP2*COS(PHI1)*COS(PHI1)
TT1= TAN(PHI1)*TAN(PHI1)
NN1= A/SQRT(1.0 - E2*SIN(PHI1)*SIN(PHI1))
RR1= A*(1.0 - E2)/((1.0-E2*SIN(PHI1)*SIN(PHI1))**1.5)
DD= X/(NN1*K0)
DD2= DD*DD
DD3= DD*DD2
DD4= DD2*DD2
DD5= DD3*DD2
DD6= DD4*DD2

PHI= PHI1 - (NN1*TAN(PHI1)/RR1)* &
     (DD2/2.0 - (5.0+3.0*TT1+10.0*CC1-4.0*CC1*CC1-9.0*EP2)*DD4/24.0 + &
     (61.0+90.0*TT1+298.0*CC1+45.0*TT1*TT1-252.0*EP2-3.0*CC1*CC1)*DD6/720.0)
LAMBDA= LAMBDA0 + (DD - (1.0+2.0*TT1+CC1)*DD3/6.0 + &
        (5.0-2.0*CC1+28.0*TT1-3.0*CC1*CC1+8.0*EP2+24.0*TT1*TT1)*DD5/120.0)/COS(PHI1)

LAT= PHI*180.0/M_PI
LONG= LAMBDA*180/M_PI

RETURN
END SUBROUTINE UTMCONVERT